# 服务说明

服务使用 Gin + Gorm 开发

核心功能包括：后台用户管理、后台权限管理、后台角色管理。

## 部署方式

> Shell 脚本部署

```shell
bash deploy.sh
```

## 重点文件说明

> ./build.sh

Golang 服务打包脚本

> .env

配置文件

其中`AUTH_TYPE` 的配置是重要核心配置，其他服务如果需要通过该服务鉴权则必须保持一致。

> /validators

该目录存储的是所有接口暴露的 Response 响应结构体

## 目录说明

目录结构遵循 Gin 框架标准

## 本地运行

1. 安装 Golang

2. 执行`go mod tidy`

3. 执行`go run main.go`
