package middleware

import (
	"authService/response"
	"authService/service/auth"
	"authService/util/constants"
	"authService/validators"

	"github.com/gin-gonic/gin"
)

func Authorize() gin.HandlerFunc {
	return func(c *gin.Context) {
		token := c.Request.Header.Get("token")
		if token == "" {
			response.Fail(c, response.ErrAuthorizationExpired)
			return
		}
		var currentUser *validators.AuthUser
		var err *response.ErrCode
		// 拿到用户系统的资料
		currentUser, err = auth.Get(token)
		if err != nil {
			response.Fail(c, err)
			return
		}
		c.Set(constants.UserCacheKey, currentUser)
		c.Next()
	}
}
