package aliyun

import (
	"fmt"
	"os"

	openapi "github.com/alibabacloud-go/darabonba-openapi/v2/client"
	dysmsapi20170525 "github.com/alibabacloud-go/dysmsapi-20170525/v3/client"
	util "github.com/alibabacloud-go/tea-utils/v2/service"
	"github.com/alibabacloud-go/tea/tea"
)

func Init() (*dysmsapi20170525.Client, error) {
	AccessKeyId := os.Getenv("ALIYUN_ACCESS_KEY_ID")
	AccessKeySecret := os.Getenv("ALIYUN_ACCESS_KEY_SECRET")
	config := &openapi.Config{
		// 您的 AccessKey ID
		AccessKeyId: &AccessKeyId,
		// 您的 AccessKey Secret
		AccessKeySecret: &AccessKeySecret,
	}
	// 访问的域名
	config.Endpoint = tea.String("dysmsapi.aliyuncs.com")
	client := &dysmsapi20170525.Client{}
	client, err := dysmsapi20170525.NewClient(config)
	if err != nil {
		return nil, err
	}

	return client, nil
}

// 发送短信验证码
func SendCaptcha(mobile string, code string) error {
	sendSmsRequest := &dysmsapi20170525.SendSmsRequest{
		PhoneNumbers:  &mobile,
		SignName:      tea.String("上医未来"),
		TemplateCode:  tea.String("SMS_243630961"),
		TemplateParam: tea.String(fmt.Sprintf("{\"code\":\"%s\"}", code)),
	}
	client, err := Init()
	if err != nil {
		return err
	}
	runtime := &util.RuntimeOptions{}
	_, err = client.SendSmsWithOptions(sendSmsRequest, runtime)
	if err != nil {
		return err
	}
	return nil
}
